#include "testlib.h"

using namespace std;

void bigFast(int a, int b, int s) {
    int r1 = rnd.wnext(a, -10) + 1;
    int r2 = rnd.next(1, b);
    if (rnd.next(2)) {
        swap(r1, r2);
    }
    int ss = rnd.wnext(s, 10) + 1;
    if (a == 1) r1 = 1;
    println(r1, r2, ss);
}

void bigSlow(int a, int b, int s) {
    int midPoint = sqrt(s);
    int r1 = min(rnd.next(midPoint, 5 * midPoint), a);
    int r2 = min(rnd.next(midPoint, 5 * midPoint), b);
    int ss = rnd.wnext(s, 30) + 1;
    if (a == 1) r1 = 1;
    println(r1, r2, ss);
}

void hardFast(int a, int b, int s) {
    int midPoint = sqrt(s);
    int r1 = min(rnd.next(midPoint / 3 + 1, midPoint), a);
    int r2 = min(rnd.next(midPoint / 3 + 1, midPoint), b);
    int ss = rnd.wnext(s, 30) + 1;
    if (a == 1) r1 = 1;
    println(r1, r2, ss);
}

void hardSlow(int a, int b, int s) {
    int r1 = rnd.next(1, min(100, a));
    int r2 = rnd.next(1, min(100, b));
    int ss = rnd.wnext(s, 50) + 1;
    if (a == 1) r1 = 1;
    println(r1, r2, ss);
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    int t = opt<int>("t"), a = opt<int>("a"), b = opt<int>("b"), s = opt<int>("s");
    auto mode = opt<string>("mode");
    cout << t << "\n";
    for (int i = 0; i < t; i++) {
        int ig = rnd.next(1, 100);
        if (mode == "bf" && ig > 4 || ig == 1) {
            bigFast(a, b, s);
        } else if (mode == "bs" && ig > 4 || ig == 2) {
            bigSlow(a, b, s);
        } else if (mode == "hf" && ig > 4 || ig == 3) {
            hardFast(a, b, s);
        } else if (mode == "hs" && ig > 4 || ig == 4) {
            hardSlow(a, b, s);
        }
    }
}
