#include "testlib.h"

using namespace std;

int gcd(int a, int b) {
    return b ? gcd(b, a % b) : a;
}

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    int t = opt<int>("t"), a = opt<int>("a"), b = opt<int>("b"), s = opt<int>("s");
    auto mode = opt<string>("mode");
    println(t);
    for (int i = 0; i < t; i++) {
        if (mode == "rnd" || !rnd.next(50)) {
            int ai = rnd.next(100000, a), bi = rnd.next(1, b), si = rnd.next(1, s);
            println(ai, bi, si);
        } else if (mode == "less") {
            int ai = rnd.wnext(100000, a, -10), si = rnd.wnext(s / 2, s, 10), bi = rnd.wnext(1, (int) sqrt(si), -1);
            println(ai, bi, si);
        } else if (mode == "more") {
            int ai = rnd.wnext(100000, a, 5), si = rnd.wnext(s / 2, s, 10), bi = rnd.wnext(2 * (int) sqrt(si), si, 2);
            println(ai, bi, si);
        }
    }
}
