#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);
    int group = validator.group() == "" ? -1 : atoi(validator.group().c_str());

    int t = inf.readInt(1, 500, "t");
    inf.readEoln();
    if  (group == 1) {
        ensuref(t <= 5, "t greater than 1");
    } else if (group == 2) {
        ensuref(t <= 100, "t greater than 100");
    }

    for (int i = 0; i < t; i++) {
        setTestCase(i + 1);

        int lim = 1e9;
        int a = inf.readInt(1, lim, "a");
        inf.readSpace();
        int b = inf.readInt(1, lim, "b");
        inf.readSpace();
        int s = inf.readInt(1, lim, "s");
        inf.readEoln();

        switch (group) {
            case 1:
                ensuref(a <= 10, "a greater than 10");
                ensuref(b <= 10, "b greater than 10");
                ensuref(s <= 10, "s greater than 10");
                break;
            case 2:
                ensuref(a <= 100, "a greater than 100");
                ensuref(b <= 100, "b greater than 100");
                ensuref(s <= 100, "s greater than 100");
                break;
            case 3:
                ensuref(s % a == 0, "a is not a divisor of s");
                ensuref(s % b == 0, "b is not a divisor of s");
                break;
            case 4:
                ensuref(a >= 100000, "a less than 100000");
                break;
            case 5:
                ensuref(a == 1, "a not equal to 1");
                break;
        }
    }

    inf.readEof();

}