#include "testlib.h"
#include <unordered_set>

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int d = opt<int>("d"), n = opt<int>("n"), bmax = opt<int>("b");

    vector<int> opts = rnd.distinct(min(n, 5), 0, n - 1);
    unordered_set<int> q(opts.begin(), opts.end());
    vector<int> a(n), b(n, -1);
    int prev = 0;
    for (int i = 0; i < n; i++) {
        if (b[i] != -1) continue;
        for (int j = i; b[j] == -1; j = (j + d) % n) {
            if (q.count(j)) {
                a[j] = rnd.next(-bmax / 2, bmax / 2);
                prev = a[j];
            } else {
                a[j] = prev;
            }
            b[j] = 0;
        }
    }
    for (int i = 0; i < n; i++) {
        b[i] = a[i] - (d == n ? 0 : a[(i + d) % n]);
    }
    println(n);
    println(b);

}