#include <bits/stdc++.h>
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,sse4a,popcnt,abm,mmx,avx,avx2,tune=native")
// #define deb(a, n) {for (int i_i = 0; i_i < n; i_i++) cout << a[i_i] << ' '; cout << '\n'; }
// #undef MAKS
// #define int ll
// #define MY_NAME "destroy"

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
// typedef long double ld;
typedef double ld;
// typedef unsigned int uint;
typedef pair<int, int> par;

template <typename T>
inline int sz(const T& t) {
    return (int)(t.size());
}

template <typename T>
inline T sq(T const &t) {
    return t * t;
}

template <typename T>
inline void maxeq(T& t1, const T& t2) {
    t1 = max(t1, t2);
}

template <typename T>
inline void mineq(T& t1, const T& t2) {
    t1 = min(t1, t2);
}

template <typename T, const size_t N>
ostream& operator<<(ostream& os, const array<T, N>& a) {
#ifdef MAKS
    if (sz(a) == 0) {
        os << "E";
    }
#endif  // MAKS
    for (const T &i : a) {
        os << i << ' ';
    }
    os << '\n';
    return os;
}

template <typename T>
ostream& operator<<(ostream& os, const vector<T>& a) {
#ifdef MAKS
    if (sz(a) == 0) {
        os << "E";
    }
#endif  // MAKS
    for (const T &i : a) {
        os << i << ' ';
    }
    os << '\n';
    return os;
}

template <typename T>
ostream& operator <<(ostream &os, const set<T> &s) {
#ifdef MAKS
    if (sz(s) == 0) {
        os << "E";
    }
#endif  // MAKS
    for (const T &i : s) {
        os << i << ' ';
    }
    os << '\n';
    return os;
}

template <typename T, typename TT>
ostream& operator <<(ostream &os, const map<T, TT> &s) {
#ifdef MAKS
    if (sz(s) == 0) {
        os << "E";
    }
#endif  // MAKS
    for (const pair<T, TT> &i : s) {
        os << i << ' ';
    }
    os << '\n';
    return os;
}

template <typename T, typename TT>
ostream& operator <<(ostream &os, const unordered_map<T, TT> &s) {
#ifdef MAKS
    if (sz(s) == 0) {
        os << "E";
    }
#endif  // MAKS
    for (const pair<T, TT> &i : s) {
        os << i << ' ';
    }
    os << '\n';
    return os;
}

template <typename T, typename U>
ostream& operator <<(ostream& os, const pair<T, U> &p) {
#ifdef MAKS
    os << "(" << p.first << ' ' << p.second << ")";
#else
    os << p.first << ' ' << p.second;
#endif  // MAKS
    return os;
}

template <typename T>
void print(ostream &os, T const &t, string const &sep, string const &_end, bool need_size) {
    if (need_size) {
        os << sz(t) << '\n';
    }
    bool b = false;
    for (auto i : t) {
        if (b) {
            os << sep;
        }
        b = true;
        os << i;
    }
    os << _end;
}








inline signed solve() {
    int a, b, s;
    cin >> a >> b >> s;
    if (a < b) {
        swap(a, b);
    }

    if (b == 1) {
        ll h = s / a;
        ll o = s % a;
        // cout << " " << (h + 1) * (o + 1) << ' ' << (h + 1) * h / 2 << ' ' << a << '\n';
        ll ans = (h + 1) * (o + 1) + (ll)(h + 1) * h / 2 * a;
        return cout << ans << '\n', 0;
        // cout << ans << '\n';
    }
    if (s <= (ll)(2e4) * a) {
        ll ans = 0;
        int s0 = s;
        while (s0 >= 0) {
            ans += s0 / b + 1;
            s0 -= a;
        }
        return cout << ans << '\n', 0;
        // cout << "  " << ans << "\n";
    }
    ll ha = s / a, hb = s / b;
    ll ans = ha + hb + 1;
    int z = (ha - 1) + (hb - 1) - (__gcd(ha, hb) - 1) + 1;
    ans += (ha * hb - z) / 2;

    cout << ans << '\n';
    return 0;
}

const bool MULTITEST = 1;

signed main()
{
#ifdef MAKS
    freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    // freopen("error.txt", "w", stderr);
#else
    #ifdef MY_NAME
        freopen(MY_NAME".in", "r", stdin);
        freopen(MY_NAME".out", "w", stdout);
    #endif  // MY_NAME
#endif  // MAKS
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cout << fixed << setprecision(10);
    if (MULTITEST) {
        int t;
        // scanf("%d", &t);
        cin >> t;
        while (t--) {
            solve();
        }
        return 0;
    } else {
        solve();
    }
    return 0;
}
